# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with bootstrap
%bcond_without bootstrap_openjdk
%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/jboss/metadata/%{version}.%{reltag}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define reltag GA
%define namedversion %{version}.%{reltag}

Name:           jboss-metadata
Version:        1.0.1
Release:        9%{?dist}
Epoch:          0
Summary:        JBoss Metadata
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn -q export http://anonsvn.jboss.org/repos/jbossas/projects/metadata/tags/1.0.1.GA/ jboss-metadata-1.0.1 && tar cjf jboss-metadata-1.0.1.tar.bz2 jboss-metadata-1.0.1
Source0:        jboss-metadata-1.0.1.tar.bz2
Source1:        jboss-metadata-jpp-depmap.xml
Source2:        jboss-metadata-settings.xml
Source3:        jboss-metadata-component-info.xml
Source4:        jboss-ejb3-ext-api-1.0.0.tar.bz2
Source5:        jboss-metadata.jar
Patch0:         jboss-metadata-bootstrap-pom.patch
Patch1:         jboss-metadata-pom.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       ejb_3_0_api
Requires:       hibernate3-ejb-persistence-3.0-api
Requires:       jaxb_2_1_api
Requires:       jboss-common-core >= 0:2.2.14
Requires:       jboss-common-logging-spi
Requires:       jboss-ejb3-ext-api
Requires:       jboss-mdr
Requires:       jboss-vfs2
Requires:       jbossws >= 0:3.1.2
Requires:       jbossws-spi
Requires:       jbossxb2
Requires:       jms_1_1_api
Requires:       jpa_1_0_api
Requires:       jpackage-utils
Requires:       jta_1_0_1B_api
BuildRequires:  apache-commons-parent >= 0:5
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-release
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  jboss-ejb-3.0-api
BuildRequires:  jaxb_2_1_api
BuildRequires:  jboss-common-core >= 0:2.2.14
BuildRequires:  jboss-common-logging-spi
%if %without bootstrap
BuildRequires:  jboss-ejb3-build
BuildRequires:  jboss-ejb3-ext-api
%endif
BuildRequires:  jboss-javaee
BuildRequires:  jboss-javaee-poms
BuildRequires:  jboss-mdr
BuildRequires:  jboss-parent
BuildRequires:  jboss-vfs2
BuildRequires:  jbossws >= 0:3.1.2
BuildRequires:  jbossws-spi
BuildRequires:  jbossxb2
BuildRequires:  jboss-jms-1.1-api
BuildRequires:  jpa_1_0_api
BuildRequires:  jboss-transaction-1.0.1-api
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss metadata.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%if %with bootstrap
%setup -q -T -D -a 4
cp -pr jboss-ejb3-ext-api-1.0.0/src/main/java/* src/main/java
%patch0 -b .sav0
%endif
%patch1

cp -p %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

%build
export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=$(pwd)/m2_repo/repository

%{_bindir}/mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dskip-enforce \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.test.skip=true \
%if %without bootstrap_openjdk
        install \
%endif
        javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}

%if %without bootstrap_openjdk
install -p -m 644 target/jboss-metadata-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%else
install -p -m 644 %{SOURCE5} $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%endif
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -s ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -p -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.metadata %{name} %{namedversion} JPP %{name}

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}

%if %with repolib
install -d -m 755 $RPM_BUILD_ROOT%{repodir}
install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
install -p -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' $RPM_BUILD_ROOT%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" $RPM_BUILD_ROOT%{repodir}/component-info.xml
install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
install -p -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
%if %without bootstrap
install -p -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{repodirsrc}
%endif
install -p -m 644 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/jboss-metadata.jar
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Mon Feb 21 2011 David Walluck <dwalluck@redhat.com> 0:1.0.1-9
- (Build)Requires: jpa_1_0_api

* Tue Jan 11 2011 David Walluck <dwalluck@redhat.com> 0:1.0.1-8
- Requires: hibernate3-ejb-persistence-3.0-api

* Wed Dec 01 2010 David Walluck <dwalluck@redhat.com> 0:1.0.1-7
- Requires: jpackage-utils

* Wed Sep 22 2010 David Walluck <dwalluck@redhat.com> 0:1.0.1-6
- rebuild

* Mon Mar 08 2010 David Walluck <dwalluck@redhat.com> 0:1.0.1-5
- switch from jbossws-native to jbossws

* Thu Jan 14 2010 David Walluck <dwalluck@redhat.com> 0:1.0.1-4
- add bootstrap option for openjdk

* Fri Sep 25 2009 David Walluck <dwalluck@redhat.com> 0:1.0.1-3
- preserve-timestamps on pom

* Tue Jun 30 2009 David Walluck <dwalluck@redhat.com> 0:1.0.1-2
- add repolib
- build with external jboss-ejb3-ext-api

* Mon Jun 22 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.0.1-1.jpp5
- first release
